
#include "Layer.hpp"

namespace SPN {

	GaussianLayer::GaussianLayer() : Layer(GAUSSIAN_LAYER) {
	}

	GaussianLayer::~GaussianLayer() {
	}
	
	GaussianNode* GaussianLayer::getNode(size_t idx) {
		return (GaussianNode*)Layer::getNode(idx);
	}
	
	void GaussianLayer::setMeansUniform(double meanVal) {
		for (unsigned k = 0; k < getNumNodes(); k++) {
			GaussianNode* gaussNode = getNode(k);
			for (unsigned l = 0; l < gaussNode->getNumChildren(); l++) {
				gaussNode->setMean(gaussNode->getChild(l), meanVal);
			}
		}
	}

	void GaussianLayer::setSigmasUniform(double sigmaVal) {
		for (unsigned k = 0; k < getNumNodes(); k++) {
			GaussianNode* gaussNode = getNode(k);
			for (unsigned l = 0; l < gaussNode->getNumChildren(); l++) {
				gaussNode->setSigma(gaussNode->getChild(l), sigmaVal);
			}
		}
	}

	void GaussianLayer::setMeansRand(double minVal, double maxVal) {
		for (unsigned k = 0; k < getNumNodes(); k++)
			getNode(k)->setMeansRand(minVal, maxVal);
	}

	void GaussianLayer::setSigmasRand(double minVal, double maxVal) {
		for (unsigned k = 0; k < getNumNodes(); k++)
			getNode(k)->setSigmasRand(minVal, maxVal);
	}
		
	GaussianNode* GaussianLayer::operator() (size_t idx) {
		return getNode(idx);
	}

}
