/*
 *
 * Some useful routines for dealing with DAGs
 *
 */

#ifndef GRAPHTOOLS_HPP
#define	GRAPHTOOLS_HPP

#include "Node.hpp"
#include "TypeDefs.hpp"
#include <queue>

namespace SPN {

	void listDescendants(Node* subroot, NodeVec &desc);
	void listAncestors(Node* subroot, NodeVec &anc);
	void keepNodesOfType(NodeVec &nodes, NodeType type);
	bool topOrder(NodeVec &nodes, NodeVec &order, Node* root = NULL);
	bool checkOrder(NodeVec & desc);
	
}

#endif // GRAPHTOOLS_HPP