
#include "PDLearning.hpp"

namespace SPN {

	PDRectangle::PDRectangle() {
		nodePtrs_.clear();
		prodNodePtrs_.clear();
		parentPartitions_.clear();
		childPartitions_.clear();
		x_ = -1;
		y_ = -1;
		width_ = -1;
		height_ = -1;
		level_ = -1;
	}

	bool PDRectangle::operator<(const PDRectangle &rhs) const {
		if (x_ < rhs.x_)
			return true;
		else if (x_ > rhs.x_)
			return false;
		if (y_ < rhs.y_)
			return true;
		else if (y_ > rhs.y_)
			return false;
		if (width_ < rhs.width_)
			return true;
		else if (width_ > rhs.width_)
			return false;
		if (height_ < rhs.height_)
			return true;
		else if (height_ > rhs.height_)
			return false;
		return false;
	}

	bool PDRectangle::operator==(const PDRectangle &rhs) const {
		return ((x_ == rhs.x_) && (y_ == rhs.y_) && (width_ == rhs.width_) && (height_ == rhs.height_));
	}

	bool PDRectangle::operator!=(const PDRectangle &rhs) const {
		return ((x_ != rhs.x_) || (y_ != rhs.y_) || (width_ != rhs.width_) || (height_ != rhs.height_));
	}

	void PDRectangle::setLevelRecursive(int level) {
		if (level_ >= level)
			return;
		level_ = level;
		for (unsigned k = 0; k < childPartitions_.size(); k++) {
			for (unsigned l = 0; l < childPartitions_[k]->childRectangles_.size(); l++) {
				childPartitions_[k]->childRectangles_[l]->setLevelRecursive(level + 1);
			}
		}
	}
}


