/*
 *
 * class for counting statistics of sumnodes/sum-children
 *
 */

#ifndef STATSCOUNTERFLOAT_HPP
#define	STATSCOUNTERFLOAT_HPP

#include "Node.hpp"
#include "TypeDefs.hpp"

namespace SPN {

	class StatsCounterFloat {
	private:
		UMap<NodeId, unsigned> numNonzeroChildren_;
		UMap<NodeId, float> counts_;
		UMap<NodeId, std::map<NodeId, float> > childCounts_;

	public:
		StatsCounterFloat();
		virtual ~StatsCounterFloat();

		void clear();

		void add(const Node& sumNode, const Node& childNode, float count);
		void subtract(const Node& sumNode, const Node& childNode, float count);
		void set(const Node& sumNode, const Node& childNode, float count);
		float get(const Node& sumNode, const Node& childNode) const;
		float get(const Node& sumNode) const;
		unsigned getNumNonzeroChildren(const Node& sumNode) const;

		size_t getNumEntries() const;

		StatsCounterFloat& operator+=(StatsCounterFloat const& rhs);
		StatsCounterFloat& operator-=(StatsCounterFloat const& rhs);

	};
}

#endif	/* STATSCOUNTERFLOAT_HPP */

