
#include "Layer.hpp"

namespace SPN {

	ValLayer::ValLayer() : Layer(VAL_LAYER) {
	}

	ValLayer::~ValLayer() {
	}
	
	ValNode* ValLayer::getNode(size_t idx) {
		return (ValNode*)Layer::getNode(idx);
	}
	
	ValNode* ValLayer::operator() (size_t idx) {
		return getNode(idx);
	}

	void ValLayer::setVals(DoubleVec values) {
		size_t numNodes = getNumNodes();

		if (numNodes != values.size())
			throw std::runtime_error("error in ValLayer::setVals(DoubleVec values): "
			"values vector must contain getNumNodes() entries.");

		for (unsigned k = 0; k < numNodes; k++)
			((ValNode*)nodes_[k])->setVal(values[k]);
	}

	DoubleVec ValLayer::getVals() {
		size_t numNodes = getNumNodes();
		DoubleVec values;
		values.resize(numNodes);
		for (unsigned k = 0; k < numNodes; k++)
			values[k] = ((ValNode*)nodes_[k])->getVal();
		return values;
	}

}
