
#include "FileIO.hpp"
#include "DataSource.hpp"
#include "PDLearning.hpp"
#include <string>
#include <iostream>
#include <math.h>

using namespace SPN;
using namespace std;

string int2str(int i) {
	stringstream convert;
	convert << i;
	return convert.str();
}

string double2str(double i) {
	stringstream convert;
	convert << i;
	return convert.str();
}

int main(int argc, char **argv) {
	NetworkFactory factory;
	Network spn;
	DataSource dataSource, valDataSource;

	string fileName;
	stringstream convert;
	string useText = "Useage: " + string(argv[0]) + " modelFile dataFile";


	if (argc < 3) {
		std::cout << useText << std::endl;
		return 0;
	}

	try {
		loadNetwork(&spn, argv[1], factory);
		dataSource.readFile(argv[2]);

		if (dataSource.getNumSamples() == 0)
			return 0;

		std::cout << "SPN_DATA:txt" << std::endl;
		std::cout << dataSource.getSample(0).size() << std::endl;
		std::cout << dataSource.getNumSamples() << std::endl;

		std::vector<double> sample;
		std::vector<bool> nanMask;

		for (unsigned sIdx = 0; sIdx < (unsigned)dataSource.getNumSamples(); sIdx++) {
			sample = dataSource(sIdx);

			//
			nanMask.resize(sample.size());
			for (unsigned k = 0; k < sample.size(); k++) {
				if (std::isnan(sample[k]))
					nanMask[k] = true;
				else
					nanMask[k] = false;
			}

			spn.setVals(sample);
			spn.MPEinference();
			sample = spn.getVals();

			for (unsigned k = 0; k < sample.size(); k++)
				std::cout << sample[k] << " ";
			std::cout << std::endl;
		}
	}
	catch (std::exception &ex) {
		std::cout << ex.what() << std::endl;
		return -1;
	}

}
