function x = ISTFT_correct_window(X, numOverlap, win)
% x = ISTFT_correct_window(X, numOverlap, win)
% Inverse Short-Time Fourier Transform, using overlap-add
% correct for the used window
%

[D,N] = size(X);

FFTlen = 2*(D-1);
hop = FFTlen - numOverlap;
x = zeros(FFTlen + (N-1) * hop,1);
totalWindow = zeros(FFTlen + (N-1) * hop,1);

for k = 1:N
    F = X(:,k);
    F = [F(1:(FFTlen/2+1)); conj(F([(FFTlen/2):-1:2]))];
    
    batch = real(ifft(F));
    
    idx = (k-1)*hop;
    x(idx+1:idx+FFTlen) = x(idx+1:idx+FFTlen) + batch;
    totalWindow(idx+1:idx+FFTlen) = totalWindow(idx+1:idx+FFTlen) + win;
end

x = x ./ totalWindow;
