clear all

setPaths

speakerLabels = [1,2,18,20];
numSpeakers = length(speakerLabels);
K = 64;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Speaker dependent data %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for sCount = 1:numSpeakers
    speaker = speakerLabels(sCount);
    fprintf('Speaker: %d\n',speaker);
    
    load(sprintf('%sPreprocessSpeaker%d.mat', dataPath, speaker));
    load(sprintf('%sTrainSpeaker%d.mat', dataPath, speaker));
    
    [N,D] = size(Data);
    
    T = Data .* repmat(SIGMA, N, 1);
    T = T + repmat(MU, N, 1);
    
    [C, idx] = LBGcluster(T', K);
    save(sprintf('%sClusterings/TrainSpeaker%d_%d.mat', dataPath, speaker, K), 'C', 'idx');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Speaker independent data %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf('Speaker independent\n');

load(sprintf('%sPreprocessSpeakerIndependent.mat', dataPath));
load(sprintf('%sTrainSpeakerIndependent.mat', dataPath));

[N,D] = size(Data);

T = Data .* repmat(SIGMA, N, 1);
T = T + repmat(MU, N, 1);

[C, idx] = LBGcluster(T', K);
save(sprintf('%sClusterings/TrainSpeakerIndependent_%d.mat', dataPath, K), 'C', 'idx');
