
setPaths

%%% Signal parameters
fsWork     = 16000;
frameLen   = 512;
numOverlap = 384;
win = hamming(frameLen);

width = 24;
recHop = 4;
lookAhead = 3;

SD = 0;
speakerLabels = [1,2,18,20];
numSpeakers = length(speakerLabels);

load('telephone.mat');
[~,telephoneDelay] = max(abs(telephone.numerator));

for sCount = 1:numSpeakers
    speaker = speakerLabels(sCount);
    fprintf('Speaker: %d\n',speaker);
    
    %%% Load Data
    clear XTEST
    clear FILENAMES
    
    count = 0;
    fid = fopen(sprintf('FileLists/Test%d.txt', speakerLabels(sCount)));
    while 1
        inputline = fgetl(fid);
        if ~ischar(inputline) || isempty(inputline)
            break
        end
        
        count = count + 1;
        
        %%% read sound file
        [xInput,fsInput]= wavread([gridPath,int2str(speakerLabels(sCount)),'/',inputline]);
        if fsInput ~= fsWork
            %%% resample, subtract mean and normalize
            xInput = resample(xInput, fsWork, fsInput);            
        end
        xInput = xInput - mean(xInput);
        xInput = xInput / std(xInput);
        XTEST{count} = xInput;
        FILENAMES{count} = inputline;
        
    end
    fclose(fid);
    
    
    for k = 1:length(XTEST)
        xTrue = XTEST{k};        
        
        %%% telephone filter
        x = conv(xTrue,telephone.numerator);
        x = x(telephoneDelay:telephoneDelay+length(xTrue)-1);
        x = 0.999 * x / max(abs(x));
                
        dir = sprintf('%stelephone/speaker%d/', resultPath, speaker);
        [SUCCESS, MESS] = mkdir(dir);
        fileName = [dir, FILENAMES{k}];
        wavwrite(x, fsWork, 24, fileName);
        
        dir = sprintf('%soriginal/speaker%d/', resultPath, speaker);
        [SUCCESS, MESS] = mkdir(dir);
        fileName = [dir, FILENAMES{k}];
        xTrue = 0.999 * xTrue / max(abs(xTrue));
        wavwrite(xTrue, fsWork, 24, fileName);
    end
end


